Bug 1132465 - [FEAT] Trash translator
Summary: [FEAT] Trash translator
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: GlusterFS
Classification: Community
Component: trash-xlator
Version: mainline
Hardware: x86_64
OS: Linux
unspecified
unspecified
Target Milestone: ---
Assignee: bugs@gluster.org
QA Contact:
URL:
Whiteboard:
Depends On:
Blocks: 1214563
TreeView+ depends on / blocked
 
Reported: 2014-08-21 12:10 UTC by Jiffin
Modified: 2016-05-28 06:03 UTC (History)
5 users (show)

Fixed In Version: glusterfs-3.7.0
Doc Type: Enhancement
Doc Text:
Clone Of:
: 1214563 (view as bug list)
Environment:
Last Closed: 2016-05-28 06:03:48 UTC
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:


Attachments (Terms of Use)

Description Jiffin 2014-08-21 12:10:10 UTC
Description of problem:

Trash translator is a new feature which is used to store files removed from the mount point.This bug is to track changes related to trash translator

Comment 1 Anand Avati 2014-08-21 13:02:34 UTC
REVIEW: http://review.gluster.org/8312 (Features/trash : Combined patches for trash translator) posted (#7) for review on master by jiffin tony Thottan (jthottan@redhat.com)

Comment 2 Anand Avati 2014-09-18 06:07:58 UTC
REVIEW: http://review.gluster.org/8312 (Features/trash : Combined patches for trash translator) posted (#8) for review on master by Anoop C S (achiraya@redhat.com)

Comment 3 Anand Avati 2014-11-27 11:28:24 UTC
REVIEW: http://review.gluster.org/8312 (Features/trash : Combined patches for trash translator) posted (#9) for review on master by Anoop C S (achiraya@redhat.com)

Comment 4 Anand Avati 2014-12-01 05:35:36 UTC
REVIEW: http://review.gluster.org/8312 (Features/trash : Combined patches for trash translator) posted (#10) for review on master by jiffin tony Thottan (jthottan@redhat.com)

Comment 5 Anand Avati 2014-12-01 08:43:51 UTC
REVIEW: http://review.gluster.org/8312 (Features/trash : Combined patches for trash translator) posted (#11) for review on master by jiffin tony Thottan (jthottan@redhat.com)

Comment 6 Anand Avati 2014-12-01 15:17:11 UTC
REVIEW: http://review.gluster.org/8312 (Features/trash : Combined patches for trash translator) posted (#12) for review on master by jiffin tony Thottan (jthottan@redhat.com)

Comment 7 Anand Avati 2014-12-02 07:23:15 UTC
REVIEW: http://review.gluster.org/8312 (Features/trash : Combined patches for trash translator) posted (#13) for review on master by Anoop C S (achiraya@redhat.com)

Comment 8 Anand Avati 2015-01-28 07:07:40 UTC
REVIEW: http://review.gluster.org/8312 (Features/trash : Combined patches for trash translator) posted (#14) for review on master by Anoop C S (achiraya@redhat.com)

Comment 9 Anand Avati 2015-03-01 11:26:19 UTC
REVIEW: http://review.gluster.org/8312 (Features/trash : Combined patches for trash translator) posted (#15) for review on master by jiffin tony Thottan (jthottan@redhat.com)

Comment 10 Anand Avati 2015-03-02 07:03:22 UTC
REVIEW: http://review.gluster.org/8312 (Features/trash : Combined patches for trash translator) posted (#16) for review on master by Anoop C S (achiraya@redhat.com)

Comment 11 Anand Avati 2015-03-02 14:06:47 UTC
REVIEW: http://review.gluster.org/8312 (Features/trash : Combined patches for trash translator) posted (#17) for review on master by Anoop C S (achiraya@redhat.com)

Comment 12 Anand Avati 2015-03-03 04:48:35 UTC
REVIEW: http://review.gluster.org/8312 (features/trash : Combined patches for trash translator) posted (#18) for review on master by Anoop C S (achiraya@redhat.com)

Comment 13 Anand Avati 2015-03-03 12:43:33 UTC
REVIEW: http://review.gluster.org/8312 (Features/trash : Combined patches for trash translator) posted (#19) for review on master by jiffin tony Thottan (jthottan@redhat.com)

Comment 14 Anand Avati 2015-03-03 18:24:44 UTC
REVIEW: http://review.gluster.org/8312 (Features/trash : Combined patches for trash translator) posted (#20) for review on master by jiffin tony Thottan (jthottan@redhat.com)

Comment 15 Anand Avati 2015-03-09 07:29:53 UTC
REVIEW: http://review.gluster.org/8312 (Features/trash : Combined patches for trash translator) posted (#21) for review on master by Anoop C S (achiraya@redhat.com)

Comment 16 Anand Avati 2015-03-16 10:36:45 UTC
COMMIT: http://review.gluster.org/8312 committed in master by Vijay Bellur (vbellur@redhat.com) 
------
commit 0ef870741a2f49d47a02725aed13a95335a6e42f
Author: Anoop C S <achiraya@redhat.com>
Date:   Fri Feb 27 15:14:08 2015 +0530

    Features/trash : Combined patches for trash translator
    
    This is the combined patch set for supporting trash feature.
    http://www.gluster.org/community/documentation/index.php/Features/Trash
    
    Current patch includes the following features:
    * volume set options for enabling trash globally and
      exclusively for internal operations like self-heal
      and re-balance
    * volume set options for setting the eliminate
      path, trash directory path and maximum trashable
      file size.
    * test script for checking the functionality of the
      feature
    * brief documentation on different aspects of trash
      feature.
    
    Change-Id: Ic7486982dcd6e295d1eba0f4d5ee6d33bf1b4cb3
    BUG: 1132465
    Signed-off-by: Anoop C S <achiraya@redhat.com>
    Signed-off-by: Jiffin Tony Thottan <jthottan@redhat.com>
    Reviewed-on: http://review.gluster.org/8312
    Tested-by: Gluster Build System <jenkins@build.gluster.com>
    Reviewed-by: Vijay Bellur <vbellur@redhat.com>

Comment 17 Anand Avati 2015-03-17 11:42:10 UTC
REVIEW: http://review.gluster.org/9909 (features/trash: Avoid unnecessary logging from trash_local_wipe) posted (#1) for review on master by Anoop C S (achiraya@redhat.com)

Comment 18 Anand Avati 2015-03-18 04:08:02 UTC
COMMIT: http://review.gluster.org/9909 committed in master by Vijay Bellur (vbellur@redhat.com) 
------
commit 33944a3eb3b589b1d309826b5f431497924ac3ae
Author: Anoop C S <achiraya@redhat.com>
Date:   Tue Mar 17 16:29:53 2015 +0530

    features/trash: Avoid unnecessary logging from trash_local_wipe
    
    Even when trash translator is disabled, the following error
    is being logged for each unlink/truncate/ftruncate calls.
    
    [...] E [trash.c:221:trash_local_wipe] (--> ...
            ... ) 0-trash: invalid argument: local
    
    This change replaces GF_VALIDATE_OR_GOTO macro with simple
    if condition.
    
    Change-Id: I7e6754cd53ec7c2d84669b6d40d883a2d1eee41e
    BUG: 1132465
    Signed-off-by: Anoop C S <achiraya@redhat.com>
    Reviewed-on: http://review.gluster.org/9909
    Reviewed-by: jiffin tony Thottan <jthottan@redhat.com>
    Reviewed-by: Vijay Bellur <vbellur@redhat.com>
    Tested-by: Vijay Bellur <vbellur@redhat.com>

Comment 19 Anand Avati 2015-03-18 09:35:30 UTC
REVIEW: http://review.gluster.org/9926 (features/trash: Handling hardlinks in trash translator) posted (#1) for review on master by jiffin tony Thottan (jthottan@redhat.com)

Comment 20 Anand Avati 2015-03-24 07:18:54 UTC
COMMIT: http://review.gluster.org/9926 committed in master by Vijay Bellur (vbellur@redhat.com) 
------
commit 191ab5693d3c9a0cdedc66bb24dd5efa535963d9
Author: Jiffin Tony Thottan <jthottan@redhat.com>
Date:   Wed Mar 18 14:12:03 2015 +0530

    features/trash: Handling hardlinks in trash translator
    
    In the current code of trash translator, file is moved to
    trash directory without checking whether it is the last
    hardlink.This may lead to inconsistency for a file in that
    gluster volume.To avoid those scenarios,so a file is moved
    to trash directory only if it is the last hardlink.
    
    Change-Id: Id098e53a2236c6406ef91e6e2599ea2cff9bace3
    BUG: 1132465
    Signed-off-by: Jiffin Tony Thottan <jthottan@redhat.com>
    Reviewed-on: http://review.gluster.org/9926
    Reviewed-by: Anoop C S <achiraya@redhat.com>
    Tested-by: Gluster Build System <jenkins@build.gluster.com>
    Reviewed-by: Kaleb KEITHLEY <kkeithle@redhat.com>
    Reviewed-by: Vijay Bellur <vbellur@redhat.com>

Comment 21 Anand Avati 2015-03-24 11:02:10 UTC
REVIEW: http://review.gluster.org/9984 (features/trash : Discarding extended truncate for trash-translator) posted (#1) for review on master by jiffin tony Thottan (jthottan@redhat.com)

Comment 22 Anand Avati 2015-03-25 05:07:07 UTC
REVIEW: http://review.gluster.org/9984 (features/trash : Discarding extended truncate for trash-translator) posted (#2) for review on master by jiffin tony Thottan (jthottan@redhat.com)

Comment 23 Anand Avati 2015-03-26 06:44:03 UTC
REVIEW: http://review.gluster.org/10002 (features/trash: Removing ftruncate dead callbacks) posted (#1) for review on master by Anoop C S (achiraya@redhat.com)

Comment 24 Anand Avati 2015-03-26 06:49:39 UTC
REVIEW: http://review.gluster.org/10002 (features/trash: Removing dead callbacks) posted (#2) for review on master by Anoop C S (achiraya@redhat.com)

Comment 25 Anand Avati 2015-03-26 11:48:11 UTC
REVIEW: http://review.gluster.org/9984 (features/trash : Discarding extended truncate for trash-translator) posted (#3) for review on master by jiffin tony Thottan (jthottan@redhat.com)

Comment 26 Anand Avati 2015-03-27 07:23:39 UTC
REVIEW: http://review.gluster.org/10002 (features/trash: Removing dead callbacks) posted (#3) for review on master by Anoop C S (achiraya@redhat.com)

Comment 27 Anand Avati 2015-03-27 17:43:33 UTC
COMMIT: http://review.gluster.org/10002 committed in master by Vijay Bellur (vbellur@redhat.com) 
------
commit bc71cc39881730c8592718a5045a744387bfaea4
Author: Anoop C S <achiraya@redhat.com>
Date:   Thu Mar 26 12:00:39 2015 +0530

    features/trash: Removing dead callbacks
    
    Since ftruncate create, mkdir, writev, readv and
    unlink calls are being re-directed to corresponding
    truncate calls, we no longer need their cbks. So
    removing those cbks for now.
    
    Change-Id: I41ecde7093a555b3bf69b66afaa8eca835b4982a
    BUG: 1132465
    Signed-off-by: Anoop C S <achiraya@redhat.com>
    Reviewed-on: http://review.gluster.org/10002
    Tested-by: Gluster Build System <jenkins@build.gluster.com>
    Reviewed-by: jiffin tony Thottan <jthottan@redhat.com>
    Reviewed-by: Vijay Bellur <vbellur@redhat.com>

Comment 28 Anand Avati 2015-03-30 07:48:54 UTC
COMMIT: http://review.gluster.org/9984 committed in master by Vijay Bellur (vbellur@redhat.com) 
------
commit 3db5f3a41b7029ce8005d1e1cc01808a15cc6019
Author: Jiffin Tony Thottan <jthottan@redhat.com>
Date:   Tue Mar 24 16:29:13 2015 +0530

    features/trash : Discarding extended truncate for trash-translator
    
    Change-Id: I5c571cbb2d6da1e95831ec206639926722a9d281
    BUG: 1132465
    Signed-off-by: Jiffin Tony Thottan <jthottan@redhat.com>
    Reviewed-on: http://review.gluster.org/9984
    Tested-by: Gluster Build System <jenkins@build.gluster.com>
    Reviewed-by: Anoop C S <achiraya@redhat.com>
    Reviewed-by: Vijay Bellur <vbellur@redhat.com>

Comment 29 Anand Avati 2015-04-13 10:37:10 UTC
REVIEW: http://review.gluster.org/10215 (features/trash : fixing trash dir option) posted (#1) for review on master by jiffin tony Thottan (jthottan@redhat.com)

Comment 30 Anand Avati 2015-04-14 05:45:02 UTC
REVIEW: http://review.gluster.org/10215 (features/trash : fixing trash dir option) posted (#2) for review on master by jiffin tony Thottan (jthottan@redhat.com)

Comment 31 Anand Avati 2015-04-21 06:09:25 UTC
REVIEW: http://review.gluster.org/10215 (features/trash : fixing trash dir option) posted (#3) for review on master by jiffin tony Thottan (jthottan@redhat.com)

Comment 32 Anand Avati 2015-04-21 08:21:43 UTC
REVIEW: http://review.gluster.org/10215 (features/trash : fixing trash dir option) posted (#4) for review on master by Vijay Bellur (vbellur@redhat.com)

Comment 33 Anand Avati 2015-04-22 13:01:24 UTC
REVIEW: http://review.gluster.org/10215 (features/trash : fixing trash dir option) posted (#5) for review on master by jiffin tony Thottan (jthottan@redhat.com)

Comment 34 Anand Avati 2015-04-23 05:07:33 UTC
COMMIT: http://review.gluster.org/10215 committed in master by Vijay Bellur (vbellur@redhat.com) 
------
commit ee255e239aaa1ed5f6388c48a8919989535f3dcc
Author: Jiffin Tony Thottan <jthottan@redhat.com>
Date:   Mon Apr 13 15:23:51 2015 +0530

    features/trash : fixing trash dir option
    
    Previously, problem was caused due to buffer overflow of variable used
    in the code. This patch fix the same.
    
    Change-Id: I3df5e06044470022f9475d93d33447db35384da2
    BUG: 1132465
    Signed-off-by: Jiffin Tony Thottan <jthottan@redhat.com>
    Reviewed-on: http://review.gluster.org/10215
    Tested-by: NetBSD Build System
    Tested-by: Gluster Build System <jenkins@build.gluster.com>
    Reviewed-by: Anoop C S <achiraya@redhat.com>
    Reviewed-by: Vijay Bellur <vbellur@redhat.com>

Comment 35 Anand Avati 2015-04-26 17:26:59 UTC
REVIEW: http://review.gluster.org/10387 (features/trash : avoid unnecessary logging by trash translator when volume is started) posted (#1) for review on master by jiffin tony Thottan (jthottan@redhat.com)

Comment 36 Anand Avati 2015-04-27 04:56:01 UTC
REVIEW: http://review.gluster.org/10387 (features/trash : avoid unnecessary logging by trash translator when volume is started) posted (#2) for review on master by jiffin tony Thottan (jthottan@redhat.com)

Comment 37 Anand Avati 2015-04-29 08:39:24 UTC
REVIEW: http://review.gluster.org/10387 (features/trash : Avoid unnecessary logging from trash translator) posted (#3) for review on master by Anoop C S (achiraya@redhat.com)

Comment 38 Anand Avati 2015-04-30 06:31:03 UTC
REVIEW: http://review.gluster.org/10387 (features/trash : Avoid unnecessary logging from trash translator) posted (#4) for review on master by Anoop C S (achiraya@redhat.com)

Comment 39 Anand Avati 2015-06-10 08:28:31 UTC
REVIEW: http://review.gluster.org/10387 (features/trash : Avoid unnecessary logging from trash translator) posted (#5) for review on master by Anoop C S (achiraya@redhat.com)

Comment 40 Anand Avati 2015-06-10 13:40:13 UTC
REVIEW: http://review.gluster.org/10387 (features/trash : Avoid unnecessary logging from trash translator) posted (#7) for review on master by Anoop C S (achiraya@redhat.com)

Comment 41 Nagaprasad Sathyanarayana 2015-10-25 15:20:02 UTC
Fix for this BZ is already present in a GlusterFS release. You can find clone of this BZ, fixed in a GlusterFS release and closed. Hence closing this mainline BZ as well.


Note You need to log in before you can comment on or make changes to this bug.